## nexus 4.3.2

=== CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
# Copyright (C) 2008-2012 NeXus International Advisory Committee (NIAC)
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

# we need 2.8.8 for correct component install with CPACK for archives
if(WIN32)
    cmake_minimum_required (VERSION 2.8.8)
else()
    cmake_minimum_required (VERSION 2.8.8)
    if (${CMAKE_VERSION} VERSION_LESS 2.8.4)
        set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove this line when CMake >= 2.8.4 is required
    endif()
endif()

#
# convert a native windows path to its equivalent cygwin path
#
function(to_cygwin_path PATH RESULT)
    file(TO_CMAKE_PATH ${PATH} CP)								# changes \ to / on windows
    string(REGEX REPLACE "^([a-zA-Z]):/" "/\\1/" CP2 ${CP})   	# c:/ -> /c/
	set(${RESULT} "/cygdrive${CP2}" PARENT_SCOPE) 				# /c/ -> /cygdrive/c/
endfunction()

# set a default install prefix for windows - we will adjust for 64bit later if this is unchanged
set(DEFAULT_WIN_INSTALL_PREFIX "c:/nxinstall")
if(WIN32)
    set(CMAKE_INSTALL_PREFIX ${DEFAULT_WIN_INSTALL_PREFIX} CACHE PATH "")
endif()

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules")


#The name of our project
project (NeXus)

set (NeXus_VERSION_MAJOR 1)
set (NeXus_VERSION_MINOR 0)
set (NXLTVERSINFO '4:3:4')

# needed for windows NSIS installer
file(TO_NATIVE_PATH ${CMAKE_SOURCE_DIR} CMAKE_SOURCE_DIR_NATIVE) 
file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR} CMAKE_BINARY_DIR_NATIVE) 
string(REPLACE "\\" "\\\\" CMAKE_SOURCE_DIR_NATIVE_D ${CMAKE_SOURCE_DIR_NATIVE})
string(REPLACE "\\" "\\\\" CMAKE_BINARY_DIR_NATIVE_D ${CMAKE_BINARY_DIR_NATIVE})

find_program(SVNVERSION svnversion)

#Packages to find that are required for the build

set(HDF5_SEARCH "" CACHE PATH "Where to search for HDF5")

set(HDF4_SEARCH "" CACHE PATH "Where to search for HDF4")

set(MXML_SEARCH "" CACHE PATH "Where to search for MXML")

set(SZIP_SEARCH "" CACHE PATH "Where to search for SZIP")

set(ZLIB_SEARCH "" CACHE PATH "Where to search for ZLIB")

#CMake includes 

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckLibraryExists)

if(WIN32)
include(InstallRequiredSystemLibraries)
endif()

include(cmake_include/Utilities.cmake)
#include(cmake_include/FindPython.cmake)
include(cmake_include/FindCBFLib.cmake)
#include(cmake_include/FindJava.cmake)
#include(cmake_include/FindJNI.cmake)
include(cmake_include/FindGuile.cmake)
include(cmake_include/FindMZScheme.cmake)
include(cmake_include/FindHDF4.cmake)
include(cmake_include/FindHDF5.cmake)
include(cmake_include/FindIDL.cmake)
include(cmake_include/FindMXML.cmake)
include(cmake_include/FindOpenGenie.cmake)
include(cmake_include/FindDocbookUtils.cmake)
include(cmake_include/FindSZIP.cmake)
include(cmake_include/FindAnt.cmake)

CHECK_TYPE_SIZE("int" SIZEOF_INT)
set(HAVE_INT ${HAVE_SIZEOF_INT})
CHECK_TYPE_SIZE("long int" SIZEOF_LONG_INT)
set(HAVE_LONG_INT ${HAVE_SIZEOF_LONG_INT})
CHECK_TYPE_SIZE("long long int" SIZEOF_LONG_LONG_INT)
set(HAVE_LONG_LONG_INT ${HAVE_SIZEOF_LONG_LONG_INT})
CHECK_TYPE_SIZE("unsigned long long int" SIZEOF_UNSIGNED_LONG_LONG_INT)
set(HAVE_UNSIGNED_LONG_LONG_INT ${HAVE_SIZEOF_UNSIGNED_LONG_LONG_INT})
CHECK_TYPE_SIZE("size_t" SIZEOF_SIZE_T)
set(HAVE_SIZE_T ${HAVE_SIZEOF_SIZE_T})

CHECK_FUNCTION_EXISTS(ftime HAVE_FTIME)
CHECK_FUNCTION_EXISTS(tzset HAVE_TZSET)
CHECK_FUNCTION_EXISTS(strdup HAVE_STRDUP)

CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILE(dlfcn.h HAVE_DLFCN_H)

if (SIZEOF_LONG_LONG_INT EQUAL 8)
	set(PRINTF_INT64 "lld")
	set(PRINTF_UINT64 "llu")
elseif (WIN32)
	set(PRINTF_INT64 "I64d")
	set(PRINTF_UINT64 "I64u")
else()
	message(SEND_ERROR "Cannot printf int64 and uint64")
endif()

if(UNIX)
    CHECK_LIBRARY_EXISTS(dl dlopen "" HAVE_LIBDL)
    CHECK_LIBRARY_EXISTS(pthread pthread_open "" HAVE_LIBPTHREAD)
endif(UNIX)

#find_package(HDF5 REQUIRED)
#find_package(HDF5)
#find_package(JPEG)
find_package(XMLRPC)
#find_package(ZLIB)
find_package(LibXml2)
find_package(Doxygen)
find_package(SWIG)
find_package(TCL)
find_package(LATEX)
find_package(PythonInterp)

#Find the java runtime and sdk
find_package(Java 1.6)
find_package(JNI)

# set ZLIB_ROOT as hint to find_package
if (ZLIB_SEARCH)
    set(ZLIB_ROOT ${ZLIB_SEARCH})
elseif($ENV{ZLIB_ROOT})
    set(ZLIB_ROOT $ENV{ZLIB_ROOT})
else()
    set(ZLIB_ROOT ${HDF5_ROOT_DIR} ${HDF4_ROOT_DIR} ${SZIP_ROOT_DIR})
endif()
find_package(ZLIB)

#Find the libraries for the build.

find_library(M m)
#find_library(RPC rpc)
find_library(DL dl)
find_library(PTHREAD pthread)
find_library(TERMCAP termcap)
find_library(READLINE readline)
find_library(HISTORY history)

if(NOT WIN32)
CHECK_LIBRARY_EXISTS(${READLINE} readline "" HAVE_LIBREADLINE)
endif()

if(M)
   set(M_LINK "-lm")
endif(M)

if(DL)
   set(DL_LINK "-ldl")
endif(DL)

if(PTHREAD)
   set(PTHREAD_LINK "-lpthread")
endif(PTHREAD)

if(SZIPLIB_FOUND)
   set(SZIP_LINK "-lsz") 
else(SZIPLIB_FOUND)
   set(SZIP_LIB "")
endif(SZIPLIB_FOUND)

if(TERMCAP)
   set(TERMCAP_LINK "")
endif(TERMCAP)

if(READLINE)
   set(READLINE_LINK "${READLINE}")
endif(READLINE)

if(HISTORY)
   set(HISTORY_LINK "")
endif(HISTORY)

if (HDF5_FOUND)
#   set (HDF5_CPP "-DHDF5 -DH5_USE_16_API")
#   these are needed if HDF5 1.8 has been instaleld with H5_USE_16_API_DEFAULT 
  set(HDF5_API_DEFS "-DH5Acreate_vers=2 -DH5Aiterate_vers=2 -DH5Dcreate_vers=2 -DH5Dopen_vers=2 -DH5Eclear_vers=2 -DH5Eprint_vers=2 -DH5Epush_vers=2 -DH5Eset_auto_vers=2 -DH5Eget_auto_vers=2 -DH5Ewalk_vers=2 -DH5Gcreate_vers=2 -DH5Gopen_vers=2 -DH5Pget_filter_vers=2 -DH5Pget_filter_by_id_vers=2 -DH5Pinsert_vers=2 -DH5Pregister_vers=2 -DH5Rget_obj_type_vers=2 -DH5Tarray_create_vers=2 -DH5Tcommit_vers=2 -DH5Tget_array_dims_vers=2 -DH5Topen_vers=2")
  set (HDF5_CPP "-DHDF5 -DH5_NO_DEPRECATED_SYMBOLS ${HDF5_API_DEFS}")
endif (HDF5_FOUND)

#Options

#Build user contributions
option (BUILD_CONTRIB 
        "Should I build the user contributions?" OFF)

#Build user contributions
option (BUILD_FORTRAN_BINDINGS 
        "Should I build the fortran bindings?" OFF)

#Use HDF4 in build
option (BUILD_HDF4 
        "Should I build HDF4 bindings if libraries available?" ON)

option (BUILD_HDF5 
        "Should I build HDF4 bindings if libraries available?" ON)

#Use XML in build
option (BUILD_XML 
        "Should I build XML bindings if libraries available?" ON)
set(BUILD_MXML ${BUILD_XML})

#This is a MINGW build
option (MINGW_MSYS 
        "We are building under MINGW." OFF)

#This if we have the MS Libraries
option (HAVE_MS_LIB 
        "We are building under MINGW." OFF)

if (HAVE_MS_LIB)
    set (MS_LIB LIB)
endif (HAVE_MS_LIB)

create_have_vars(HDF4 HDF5 MXML)

#Include source files.
include_directories(${PROJECT_SOURCE_DIR}/include ${HDF5_INCLUDE_DIRS} ${HDF5_INCLUDE_DIR})


if (UNIX)
    check_add_c_compiler_flags("-Wall -Wno-unused-variable -Wno-sign-compare -Wno-comment")
    check_add_cxx_compiler_flags("-Wall -Wno-unused-variable -Wno-sign-compare -Wno-comment")
endif(UNIX)

if (BUILD_FORTRAN_BINDINGS)
    enable_language(Fortran)
endif (BUILD_FORTRAN_BINDINGS)

#We need a NXDOCDIR as a place to install the docs for various packages.
set(NXDOCDIR "share/nexus/doc")

#We need a NXEXAMPLEDIR as a place to install the examples.
set(NXEXAMPLEDIR  "share/nexus/examples")

#We need a NXINCLUDE and NX_INCLUDE as a place to install the include files.
set(NXINCLUDE  "include")
set(NX_INCLUDE "include/nexus")

configure_file("${CMAKE_SOURCE_DIR}/include/nxconfig_h_cmake.in" "${CMAKE_BINARY_DIR}/include/nxconfig.h" @ONLY)
include_directories("${CMAKE_BINARY_DIR}/include")

if(MSVC)
# warning 4820 is byte padding in structures
# warning 4996 is about using _strdup ratherthan strdup etc
# /W4 rather than /Wall
# /Zi to get pdb file in all configurations
    set(NX_CFLAGS "/W4 /wd4820 /wd4996 /Zi")
    set(NX_CPP -D_CRT_SECURE_NO_WARNINGS)
	set(CMAKE_DEBUG_POSTFIX "D")
#	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /INCREMENTAL" CACHE STRING "" FORCE)   # workaround for problems
endif(MSVC)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NX_CFLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${NX_CFLAGS}")

if (CMAKE_SIZEOF_VOID_P MATCHES "8")
    set(ARCH64 1)
	set(ARCHSUFFIX "64")
else()
    set(ARCH64 0)
	set(ARCHSUFFIX "")
endif()

# if we haven't changed the default windows install prefix, adjust for 64 bit
if(${CMAKE_INSTALL_PREFIX} STREQUAL ${DEFAULT_WIN_INSTALL_PREFIX})
    set(CMAKE_INSTALL_PREFIX "${DEFAULT_WIN_INSTALL_PREFIX}${ARCHSUFFIX}" CACHE PATH "" FORCE)
endif()

if(WIN32)
	if(ARCH64)
		include_directories("${NEXUS_THIRD_PARTY}/win64/include")
		file(GLOB EXTRA_DLLS "${NEXUS_THIRD_PARTY}/win64/bin/*.dll")
	else()
		include_directories("${NEXUS_THIRD_PARTY}/win32/include")
		file(GLOB EXTRA_DLLS "${NEXUS_THIRD_PARTY}/win32/bin/*.dll")
	endif()
	install(FILES ${EXTRA_DLLS} DESTINATION bin COMPONENT Runtime)
endif()

# Recurse into the subdirectories.
add_subdirectory (src)
add_subdirectory (bindings)
add_subdirectory (applications)
#add_subdirectory (config)
#add_subdirectory (contrib)
#add_subdirectory (definitions)
add_subdirectory (doc)
add_subdirectory (examples)
add_subdirectory (include)
#add_subdirectory (InstallerBits)
#add_subdirectory (macosx_install_kit)
#add_subdirectory (scripts)
add_subdirectory (test)
#add_subdirectory (third_party)
#add_subdirectory (vms)
#add_subdirectory (windows)
#add_subdirectory (Windows_extra)

#
# set CPack packaging options
#
configure_file("${PROJECT_SOURCE_DIR}/CPackOptions.cmake.in" "${PROJECT_BINARY_DIR}/CPackOptions.cmake"  @ONLY)
set(CPACK_PROJECT_CONFIG_FILE "${PROJECT_BINARY_DIR}/CPackOptions.cmake")
set (CPACK_GENERATOR TGZ) # not use ZIP on UNIX as problem with symlinks
set (CPACK_SOURCE_GENERATOR TGZ) # not use ZIP on UNIX as problem with symlinks
if(WIN32)
    set (CPACK_GENERATOR ${CPACK_GENERATOR};ZIP;NSIS)
    set (CPACK_SOURCE_GENERATOR ${CPACK_SOURCE_GENERATOR};ZIP) 
elseif(APPLE)
    set (CPACK_GENERATOR ${CPACK_GENERATOR};PackageMaker)
elseif(CYGWIN)
    set (CPACK_GENERATOR ${CPACK_GENERATOR};CygwinBinary)
    set (CPACK_SOURCE_GENERATOR ${CPACK_SOURCE_GENERATOR};CygwinSource) 
elseif(UNIX)
    set (CPACK_GENERATOR ${CPACK_GENERATOR};DEB;RPM)
endif()
# Include of CPack must always be last
include(CPack)

=== applications/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2010 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

#The LibXML 2 Libraries
find_package(LibXml2)

# Recurse into the subdirectories.

add_subdirectory (NXbrowse)
add_subdirectory (NXdir)
add_subdirectory (NXconvert)

if (BUILD_FORTRAN_BINDINGS AND CMAKE_Fortran_COMPILER_WORKS)
    add_subdirectory (NXdump)
endif()

if (HAVE_MXML)
add_subdirectory (nxingest)
endif(HAVE_MXML)

add_subdirectory (NXtraverse)

if(Java_JAVAC_EXECUTABLE AND ANT_FOUND)
    add_subdirectory (NXvalidate)
endif(Java_JAVAC_EXECUTABLE AND ANT_FOUND)

if(LIBXML2_FOUND)
    add_subdirectory (NXsummary)
    add_subdirectory (NXtranslate)
endif(LIBXML2_FOUND)

install (PROGRAMS nxdiff DESTINATION bin COMPONENT Runtime)

=== bindings/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================
# Recurse into the subdirectories.
add_subdirectory (cpp)
if (BUILD_FORTRAN_BINDINGS AND CMAKE_Fortran_COMPILER_WORKS)
    add_subdirectory (f77)
    add_subdirectory (f90)
endif ()
#add_subdirectory (idl)
if (NOT(Java_JAVAC_EXECUTABLE MATCHES NOTFOUND))
    add_subdirectory (java)
endif ()
#add_subdirectory (matlab)
if (PYTHONINTERP_FOUND)
    add_subdirectory (python)
endif (PYTHONINTERP_FOUND)
#add_subdirectory (swig)

=== contrib/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

add_subdirectory (applications)
add_subdirectory (bindings)

=== doc/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

add_subdirectory (api)
add_subdirectory (doxygen)
#add_subdirectory (howto)
add_subdirectory (nxdict)
add_subdirectory (tech_ref)
#add_subdirectory (tutorial)

install (FILES README.doc DESTINATION ${NXDOCDIR} COMPONENT Documentation)

=== examples/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================


install (FILES README.examples DESTINATION ${NXEXAMPLEDIR}/ COMPONENT Examples)

=== include/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================


SET(INCLUDE_FILES napi.h napiu.h)

INSTALL (FILES napi.h napiu.h DESTINATION ${NXINCLUDE}/ COMPONENT Development)
INSTALL (FILES napi.h napiu.h DESTINATION ${NX_INCLUDE}/ COMPONENT Development)

=== src/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#  MA  02111-1307  USA
#
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

add_definitions(-DIN_NEXUS_LIBRARY=1 ${NX_CPP})

set (NAPISRC napi.c napiu.c nxstack.c nxstack.h stptok.c  nxdataset.c nxdataset.h nx_stptok.h)

if (HAVE_HDF4)
  set (NAPISRC ${NAPISRC} napi4.c)
  add_definitions(-DHDF4 ${HDF4_DEFINITIONS} ${HDF4_CPP})
  include_directories(${HDF4_INCLUDE_DIRS})
  file(GLOB HDF4DLLS "${HDF4_ROOT_DIR}/bin/*.dll") 
  install (FILES ${HDF4DLLS} DESTINATION bin COMPONENT Runtime)
endif (HAVE_HDF4)

if (HAVE_HDF5)
  set (NAPISRC ${NAPISRC} napi5.c)
  add_definitions(-DHDF5 ${HDF5_DEFINITIONS} ${HDF5_CPP})
  include_directories(${HDF5_INCLUDE_DIRS})
  file(GLOB HDF5DLLS "${HDF5_ROOT_DIR}/bin/*.dll") 
  install (FILES ${HDF5DLLS} DESTINATION bin COMPONENT Runtime)
endif (HAVE_HDF5)

if(HAVE_MXML)
    set (NAPISRC ${NAPISRC} nxxml.c nxio.c nxio.h)
    add_definitions(-DNXXML ${MXML_DEFINITIONS} ${MXML_CPP})
	include_directories(${MXML_INCLUDE_DIRS})
endif(HAVE_MXML)

# need napi_exports2.c  on win32 but not win64
if (WIN32)
    if (CMAKE_CL_64)
        set(NAPISRC ${NAPISRC} napi_exports2.c napi_exports.h)
    else()
        set(NAPISRC ${NAPISRC} napi_exports.c napi_exports2.c napi_exports.h)
	endif()
endif (WIN32)

set_property(SOURCE ${NAPISRC} APPEND PROPERTY COMPILE_FLAGS ${NX_CFLAGS})

file(STRINGS ${PROJECT_SOURCE_DIR}/src/nexus_symbols.txt NEXUS_SYMBOLS)

set (NX_LIBS  ${HDF4_LINK} ${READLINE_LINK} ${M_LINK} ${DL_LINK} ${PTHREAD_LINK} ${DF_LINK}
                      ${TERMCAP_LINK} ${HISTORY_LINK} ${JPEG_LIBRARIES} ${SZIP_LIBRARIES} ${ZLIB_LIBRARIES}  )
#if (MINGW_MSYS)
#  set (MINGW_SRC napi_exports.c napi_exports2.c napi_exports.h)
#  file(STRINGS ${PROJECT_SOURCE_DIR}/src/nexus_symbols_win.txt
#       NEXUS_SYMBOLS_WIN)
#  file(WRITE ${PROJECT_SOURCE_DIR}/src/nexus_symbols.sym ${NEXUS_SYMBOLS}
#       ${NEXUS_SYMBOLS_WIN})
#
#  if (HAVE_MS_LIB)
#    file(REMOVE libNeXus.dll.lib libNeXus.dll.exp)
#    execute_process(
#      COMMAND ${MS_LIB} /MACHINE:I386 /DEF:libNeXus.def /OUT:libNeXus.dll.lib)
#  endif (HAVE_MS_LIB)
#
#else (MINGW_MSYS)
#  file(WRITE ${PROJECT_SOURCE_DIR}/src/nexus_symbols.sym ${NEXUS_SYMBOLS})
#endif (MINGW_MSYS)

#Make NeXus Static Library
add_library (NeXus_Static_Library STATIC ${NAPISRC})

set_target_properties(NeXus_Static_Library PROPERTIES OUTPUT_NAME NeXusStatic)

target_link_libraries(NeXus_Static_Library ${HDF5_STATIC_LIBRARIES} ${HDF4_STATIC_LIBRARIES} ${MXML_STATIC_LIBRARIES}  ${NX_LIBS})

#Make NeXus Shared Library

add_library (NeXus_Shared_Library SHARED ${NAPISRC})

#set_property(TARGET NeXus_Shared_Library APPEND PROPERTY COMPILE_DEFINITIONS _HDF5USEDLL_ _HDFDLL_)
set_property(TARGET NeXus_Shared_Library APPEND PROPERTY COMPILE_DEFINITIONS H4_BUILT_AS_STATIC_LIB)
set_property(TARGET NeXus_Static_Library APPEND PROPERTY COMPILE_DEFINITIONS H4_BUILT_AS_STATIC_LIB)

if (CMAKE_CL_64)
   set(DEF_FILE ${PROJECT_SOURCE_DIR}/Windows_extra/libNeXus-0-x64.def)
else()
   set(DEF_FILE ${PROJECT_SOURCE_DIR}/Windows_extra/libNeXus-0-Win32.def)
endif()

#Note - library version needs to be got from somewhere?
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set_target_properties(NeXus_Shared_Library PROPERTIES OUTPUT_NAME libNeXus-0
                      VERSION 1.0 SOVERSION 4 )
	if (MSVC)
	    set_property(TARGET NeXus_Shared_Library APPEND PROPERTY LINK_FLAGS /def:${DEF_FILE})
	endif(MSVC)
else(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set_target_properties(NeXus_Shared_Library PROPERTIES OUTPUT_NAME NeXus
                      VERSION 1.0 SOVERSION 4)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")

target_link_libraries(NeXus_Shared_Library ${HDF5_STATIC_LIBRARIES} ${HDF4_STATIC_LIBRARIES} ${MXML_STATIC_LIBRARIES} ${NX_LIBS})

#if(HAVE_MXML)
#if(MXMLLIB_FOUND)
#    target_link_libraries(NeXus_Static_Library ${MXML})
#    target_link_libraries(NeXus_Shared_Library ${MXML})
#else()
#    target_link_libraries(NeXus_Static_Library MXML_Static_Library)
#    target_link_libraries(NeXus_Shared_Library MXML_Shared_Library)
#endif(MXMLLIB_FOUND)
#endif(HAVE_MXML)

install (TARGETS NeXus_Static_Library NeXus_Shared_Library
         RUNTIME DESTINATION bin COMPONENT Runtime
         LIBRARY DESTINATION lib COMPONENT Runtime
         ARCHIVE DESTINATION lib/nexus COMPONENT Development)

#if(WIN32)
#install_pdb (NeXus_Shared_Library)
#endif()

=== test/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

SET (NXEXAMPLE_FILES napif4_test.f  napif5_test.f  napif_test.f  napi_test.c  napi_test_cpp.cxx  NXtest.f90)

INSTALL (FILES ${NXEXAMPLE_FILES} DESTINATION ${NXEXAMPLEDIR} COMPONENT Examples)

add_executable(napi_test_hdf5 napi_test.c)
target_link_libraries(napi_test_hdf5 NeXus_Shared_Library)

add_test(napi_test_hdf5 ${EXECUTABLE_OUTPUT_PATH}/napi_test_hdf5)
#set_property(TEST napi_test_hdf5 PROPERTY PASS_REGULAR_EXPRESSION kkk)

=== third_party/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#  
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#  
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
# 
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
# 
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free 
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#  MA  02111-1307  USA
#             
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

add_subdirectory (tclap)
if(HAVE_XML)
add_subdirectory (mxml-2.6)
endif(HAVE_XML)

=== applications/NXbrowse/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2011 Stephen Rankin
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#  MA  02111-1307  USA
#
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

add_executable (nxbrowse NXbrowse.c)

target_link_libraries(nxbrowse NeXus_Shared_Library 
                      ${READLINE_LINK}  ${M_LINK}
                      ${DL_LINK} ${PTHREAD_LINK} ${DF_LINK} ${TERMCAP_LINK}
                      ${HISTORY_LINK})

install (TARGETS nxbrowse DESTINATION bin COMPONENT Runtime)
install (FILES nxbrowse.1 DESTINATION man/man1 COMPONENT Documentation)

=== applications/NXconvert/CMakeLists.txt ===
## Process this file with cmake
#====================================================================
#  NeXus - Neutron & X-ray Common Data Format
#
#  CMakeLists for building the NeXus library and applications.
#
#  Copyright (C) 2010 Stephen Rankin
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free
#  Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#  MA  02111-1307  USA
#
#  For further information, see <http://www.nexusformat.org>
#
#
#====================================================================

include_directories(../../third_party ../../bindings/cpp)

add_executable (nxconvert nxconvert.cpp nxconvert_common.h )

set(NXCONVERT_LIB_SRC nxconvert_common.cpp nxconvert_common.h )

add_library (NXconvert_Static_Library STATIC ${NXCONVERT_LIB_SRC} )

add_library (NXconvert_Shared_Library SHARED ${NXCONVERT_LIB_SRC} )

#set_target_properties(NXconvert_Static_Library PROPERTIES OUTPUT_NAME NXconvert)

target_link_libraries(NXconvert_Static_Library NeXus_CPP_Static_Library
                       ${READLINE_LINK} ${M_LINK} ${DL_LINK}
                      ${PTHREAD_LINK} ${DF_LINK} ${TERMCAP_LINK} ${HISTORY_LINK})

target_link_libraries(NXconvert_Shared_Library NeXus_CPP_Shared_Library
                       ${READLINE_LINK} ${M_LINK} ${DL_LINK}
                      ${PTHREAD_LINK} ${DF_LINK} ${TERMCAP_LINK} ${HISTORY_LINK})

target_link_libraries(nxconvert NXconvert_Shared_Library
                      ${READLINE_LINK} ${M_LINK} ${DL_LINK} ${PTHREAD_LINK}
                      ${DF_LINK} ${TERMCAP_LINK} ${HISTORY_LINK})

set_property(TARGET NXconvert_Shared_Library PROPERTY ENABLE_EXPORTS YES) 

install (TARGETS NXconvert_Static_Library NXconvert_Shared_Library nxconvert
         RUNTIME DESTINATION bin COMPONENT Runtime
         LIBRARY DESTINATION lib COMPONENT Runtime
         ARCHIVE DESTINATION lib/nexus COMPONENT Development)

install (FILES nxconvert.1 DESTINATION man/man1 COMPONENT Documentation)

## nexus 4.3.2-svn1919

=== debian/changelog ===
nexus (4.3.2-svn1919-1) unstable; urgency=low

  * upstream: fix problem with null terminated fixed size strings in nxbrowse
  * force building with hdf5 (ubuntu managed to build without)

 -- Tobias Stefan Richter <tsr-debian@achos.com>  Wed, 13 Nov 2013 14:36:50 +0000

nexus (4.3.2-svn1915-1) unstable; urgency=low

  * new upstream snapshot
  * better support from compression from Java
  * bug fixes

 -- Tobias Stefan Richter <tsr-debian@achos.com>  Sat, 14 Sep 2013 18:19:10 +0100

=== debian/control ===
Source: nexus
Priority: extra
Maintainer: Tobias Stefan Richter <tsr-debian@achos.com>
Uploaders: Carlo Segre <segre@debian.org>
Build-Depends: autoconf, automake, debhelper (>= 7), autotools-dev, libtool, 
 libmxml-dev, libhdf5-dev, libhdf4g-dev, 
 default-jdk | java2-sdk, python-all-dev, python-support, python-numpy, 
 libxml2-dev, ant
Standards-Version: 3.9.4
Section: libs

Package: libnexus0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: http://www.nexusformat.org/
Description: NeXus scientific data file format - runtime libraries
 NeXus is a common data format for neutron, x-ray, and muon science. It
 is being developed as an international standard by scientists and
 programmers representing major scientific facilities in Europe, Asia,
 Australia, and North America in order to facilitate greater cooperation
 in the analysis and visualization of neutron, x-ray, and muon data.
 .
 This is the package containing the runtime libraries.

Package: libnexus0-dev
Section: libdevel
Architecture: any
Depends: libnexus0 (= ${binary:Version}), ${misc:Depends} 
Homepage: http://www.nexusformat.org/
Description: NeXus scientific data file format - development libraries
 NeXus is a common data format for neutron, x-ray, and muon science. It
 is being developed as an international standard by scientists and
 programmers representing major scientific facilities in Europe, Asia,
 Australia, and North America in order to facilitate greater cooperation
 in the analysis and visualization of neutron, x-ray, and muon data.
 .
 This is the package containing the development libraries.

Package: libnexus0-java
Section: java
Architecture: any
Depends: libnexus0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends} 
Homepage: http://www.nexusformat.org/
Description: NeXus scientific data file format - java libraries
 NeXus is a common data format for neutron, x-ray, and muon science. It
 is being developed as an international standard by scientists and
 programmers representing major scientific facilities in Europe, Asia,
 Australia, and North America in order to facilitate greater cooperation
 in the analysis and visualization of neutron, x-ray, and muon data.
 .
 This is the package containing the java libraries.

Package: python-nxs
Replaces: libnexus0-python
Conflicts: libnexus0-python
Section: python
Architecture: all
Depends: libnexus0 (>= ${binary:Version}), ${python:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Homepage: http://www.nexusformat.org/
Description: NeXus scientific data file format - python binding
 NeXus is a common data format for neutron, x-ray, and muon science. It
 is being developed as an international standard by scientists and
 programmers representing major scientific facilities in Europe, Asia,
 Australia, and North America in order to facilitate greater cooperation
 in the analysis and visualization of neutron, x-ray, and muon data.
 .
 This is the package containing the Python bindings.

Package: nexus-tools
Section: science
Architecture: any
Depends: libnexus0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends} 
Homepage: http://www.nexusformat.org/
Description: NeXus scientific data file format - applications
 NeXus is a common data format for neutron, x-ray, and muon science. It
 is being developed as an international standard by scientists and
 programmers representing major scientific facilities in Europe, Asia,
 Australia, and North America in order to facilitate greater cooperation
 in the analysis and visualization of neutron, x-ray, and muon data.
 .
 This is the package containing some applications for reading and writing
 NeXus files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# shared library versions, option 1
#version=2.0.5
#major=2
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
# version=`ls src/.libs/lib*.so.* | \
#  awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
# major=`ls src/.libs/lib*.so.* | \
#  awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure:
	sh autogen.sh

config.status: configure
	dh_testdir
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --with-hdf5=/usr CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS) -Wl,-z,defs" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" --with-java-home=/usr/lib/jvm/default-java --with-python=/usr JAVACFLAGS="-source 1.5 -target 1.5"
	sed < libtool > libtool-2 -e 's/^hardcode_libdir_flag_spec.*$$/hardcode_libdir_flag_spec=" -D__LIBTOOL_IS_A_FOOL__ "/' -e '/^archive_cmds="/s/"$$/ \\$$deplibs"/'
	mv libtool-2 libtool
	chmod 755 libtool

build: build-arch build-indep

build-arch: build-stamp

build-indep:

build-stamp:  config.status
	dh_testdir
	$(MAKE)
	touch $@

clean: config.status
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	$(MAKE) maintainer-clean
	rm -f config.sub config.guess
	rm -fr config || true
	rm -fr .pc || true
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build-indep install
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installexamples -i
	dh_install -i
#	dh_installmenu -i
#	dh_installdebconf	 -i
#	dh_installinfo -i
	dh_installman -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_python2 -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a
#	dh_installmenu -a
#	dh_installdebconf	 -a
#	dh_installinfo -a
	dh_installman -a
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -X /usr/lib/jni -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
